/*

   Copyright 2011 Toby Kenney

   This file is part of Cold.

   Cold is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   Cold is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Cold.  If not, see <http://www.gnu.org/licenses/>.

 */

#ifndef DISTRIBUTIONS_H
#define DISTRIBUTIONS_H
class constraint;

class Distribution{
public:
  int num;
  int pars;
  virtual long double *vals(const long double *p)=0;//
  virtual long double *derivvals(const long double *p)=0;//
  virtual long double *secdervals(const long double *p)=0;//
  virtual void seed(const long double *seeds,long double *to)=0;
  virtual int numconstraints()=0;
  virtual void putconstraint(constraint *c,int firstpar)=0;
  //  virtual long double *vals(const long double p1,...)=0;//
  //  virtual long double *derivvals(const long double p1,...)=0;//
  //  virtual long double *secdervals(const long double p1,...)=0;//
};

Distribution* getdistribution(const char *dname,int num);
//reads a distribution from the string.

void deletedistribution(Distribution *d);
//Deletes a distribution obtained using getdistribution.
#endif
